/* Helicostat program V1.0                              */

/* Author : Philippe Kauffmann                          */

/* This is command management code                      */

#include "main.h"

// fontion locale gestion des manches clavier
void testContKey(int raydium_key_last);

//Donnes externes
extern int moteur;      // boolen de marche/arrt moteur
extern int zoom;        // dfinition de l'angle visuel
// Sound variables
extern dReal soundPitch, soundGain;

// Donnes locales
// hauteur du bruit du moteur
static int pitch;

// gestion des boutons du joystick
void joyCom(void) {
static int boutonZP = 0, boutonZM = 0; // zoom plus et moins
static int boutonNH = 0, boutonSS = 0; // changer d'hlicostat est start/stop
static int boutonVP = 0, boutonVM = 0; // volume plus et moins

if (raydium_joy_button[jc.BZP] && (!boutonZP)) { // augmenter le zoom
    boutonZP = 25;
    if (zoom>10) zoom -= 10;
    } else if(boutonZP>0) boutonZP--;
if (raydium_joy_button[jc.BZM] && (!boutonZM)) { // diminuer le zoom
    boutonZM = 25;
    if (zoom<90) zoom += 10;
    } else if(boutonZM>0) boutonZM--;
if (raydium_joy_button[jc.BVP] && (!boutonVP)) { // augmenter le volume
    boutonVP = 25;
    if (soundGain<1.0) soundGain += 0.2;
    raydium_sound_SetSourceGain(sonMoteurs,soundGain);
    } else if(boutonVP>0) boutonVP--;
if (raydium_joy_button[jc.BVM] && (!boutonVM)) { // diminuer le volume
    boutonVM = 25;
    if (soundGain>0) soundGain -= 0.2;
    raydium_sound_SetSourceGain(sonMoteurs,soundGain);
    } else if(boutonVM>0) boutonVM--;
if (raydium_joy_button[jc.BNH]) {
    if (!boutonNH) { // nouvel hlicostat
        boutonNH = 1;
        raydium_ode_object_delete(helicostat);
        raydium_sound_SetSourceGain(sonMoteurs,0.0);
        moteur = 0; helicostat=0;
        helicostat = creerhelicostat(); }
    } else boutonNH = 0;
if (raydium_joy_button[jc.BSS]) {
    if (!boutonSS) { // marche arrt moteurs
        boutonSS = 1;
        if(moteur) {
            moteur=0;
            raydium_sound_SetSourceGain(sonMoteurs,0);
            raydium_ode_motor_speed(moteur1,1.0);
            raydium_ode_motor_speed(moteur2,-1.0); }
        else {
            moteur=1;
            raydium_sound_SetSourceGain(sonMoteurs,soundGain);
            raydium_ode_motor_speed(moteur1,100.0);
            raydium_ode_motor_speed(moteur2,-100.0);}
        }
    } else boutonSS = 0;
}

// gestion du clavier
int keyCom(void) {
// temps de mmorisation de la dernire touche
static int count = 30;
// position de la camra
static int typeCam = 0;

testContKey(raydium_key_last);
switch(raydium_key_last) {
    case 0 : if (count) count--;
             else {
                  direction = STOP;
                  count=30;
                  if(pitch!=0) {
                        pitch = 0; soundPitch = 1.0;
                        raydium_sound_SetSourcePitch(sonMoteurs,soundPitch); }
             }
             break; //Arrter la dernire action
    case 1027 :     exit(0);
    case 1000+' ' : {
                    raydium_ode_object_delete(helicostat);
                    raydium_sound_SetSourceGain(sonMoteurs,0.0);
                    moteur = 0; helicostat=0;
                    helicostat = creerhelicostat();
                }   break;
    case 1000+'k' : direction = GAUCHE;break; //glisser   gauche
    case 1000+'m' : direction = DROITE;break; //glisser  droite
    case 1000+'q' : direction = TGAUCHE;break; //Tourner  gauche
    case 1000+'d' : direction = TDROITE;break; //Tourner  droite
    case 1000+'s' : if(moteur) {
                            moteur=0;
                            raydium_sound_SetSourceGain(sonMoteurs,0);
                            raydium_ode_motor_speed(moteur1,1.0);
                            raydium_ode_motor_speed(moteur2,-1.0);
                    } else {
                            moteur=1;
                            raydium_sound_SetSourceGain(sonMoteurs,soundGain);
                            raydium_ode_motor_speed(moteur1,100.0);
                            raydium_ode_motor_speed(moteur2,-100.0);
                            }
                            break; // Basculement tat moteurs
    case 1000+'l' : loadParam();break;         // load helicostat parameters
    case GLUT_KEY_PAGE_UP : if (zoom>10) zoom -= 10;break; // gestion du zoom manuel
    case GLUT_KEY_PAGE_DOWN : if (zoom<90) zoom += 10;break;
    case GLUT_KEY_UP : if (soundGain<1.0) {
                            soundGain += 0.2;
                            raydium_sound_SetSourceGain(sonMoteurs,soundGain); }
                        break; // gestion du son
    case GLUT_KEY_DOWN : if (soundGain>0.2) {
                            soundGain -= 0.2;
                            raydium_sound_SetSourceGain(sonMoteurs,soundGain); }
                        break;
    case GLUT_KEY_F1 : // orientation de la camra
    case GLUT_KEY_F2 :
    case GLUT_KEY_F3 : typeCam = raydium_key_last;
    }
return typeCam;
}

// affichage de texte  l'cran
void affichTexte(void) {
raydium_osd_printf(2,2,16,0.5,"font2.tga","Helicostat V1.0");
raydium_osd_printf(2,98,16,0.5,"font2.tga","%4.2fm/s %2dFPS", modVBallon, raydium_render_fps);
raydium_osd_printf(30,2,16,0.5,"font2.tga","Joystick : %s",raydium_joy_name);
if(raydium_key[GLUT_KEY_F5]) {
    raydium_osd_printf(2,95,16,0.5,"font2.tga","pitch %4.2f level %4.2f", soundPitch, soundGain);
    raydium_osd_printf(2,92,16,0.5,"font2.tga","%02d axes %02d buttons",raydium_joy_n_axes,raydium_joy_n_buttons);
    raydium_osd_printf(2,89,16,0.5,"font2.tga","%f %f",raydium_joy_axis[0],raydium_joy_axis[1]);
    raydium_osd_printf(2,86,16,0.5,"font2.tga","%f %f",raydium_joy_axis[2],raydium_joy_axis[3]);
    raydium_osd_printf(2,83,16,0.5,"font2.tga","%1d %1d %1d %1d",raydium_joy_button[0],raydium_joy_button[1], \
                   raydium_joy_button[2],raydium_joy_button[3]);
    raydium_osd_printf(2,80,16,0.5,"font2.tga","%1d %1d %1d %1d",raydium_joy_button[4],raydium_joy_button[5], \
                   raydium_joy_button[6],raydium_joy_button[7]);
    raydium_osd_printf(2,77,16,0.5,"font2.tga","%1d %1d %1d %1d",raydium_joy_button[8],raydium_joy_button[9], \
                   raydium_joy_button[10],raydium_joy_button[11]);
    raydium_osd_printf(2,74,16,0.5,"font2.tga","%1d %1d %1d %1d",raydium_joy_button[12],raydium_joy_button[13], \
                   raydium_joy_button[14],raydium_joy_button[15]);
    raydium_osd_printf(2,71,16,0.5,"font2.tga","%1d %1d %1d %1d",raydium_joy_button[16],raydium_joy_button[17], \
                   raydium_joy_button[18],raydium_joy_button[19]);
    raydium_osd_printf(2,68,16,0.5,"font2.tga","%1d %1d %1d %1d",raydium_joy_button[20],raydium_joy_button[21], \
                   raydium_joy_button[22],raydium_joy_button[23]);
    }
}

// gestion des touches des manches
void testContKey(int raydium_key_last) {

if(raydium_key_last == jc.CAVANT) direction = AVANT; //glisser en avant
if(raydium_key_last == jc.CARRIERE) direction = ARRIERE; //glisser en arrire
if(raydium_key_last == jc.CHAUT) {
    direction = HAUT;
    if(pitch!=1) {
        pitch=1; soundPitch = 1.1;
        raydium_sound_SetSourcePitch(sonMoteurs,soundPitch); }
    }
if(raydium_key_last == jc.CBAS) {
    direction = BAS;
    if(pitch!=-1) {
        pitch=-1; soundPitch = 0.9;
        raydium_sound_SetSourcePitch(sonMoteurs,soundPitch); }
    }
}
