/* Helicostat program V1.0                              */

/* Author : Philippe Kauffmann                          */

/* This is the parameter reading from file code         */

#include "main.h"

// function to load helicostat parameters from external file
void loadParam(void)
{
FILE * param;       // file pointer
char symbol[21];    // parameter symbol read
dReal valeur;       // parameter value read

param = fopen("../modeles/modele.par", "rt");
if(param) {
    while(!feof(param)) {
        fscanf(param,"%s %f", symbol, &valeur);
        if (!strcmp(symbol, "M_BALLON")) p.M_BALLON = valeur;
        if (!strcmp(symbol, "M_AIR")) p.M_AIR = valeur;
        if (!strcmp(symbol, "M_NACELLE")) p.M_NACELLE = valeur;
        if (!strcmp(symbol, "T_BALLON_T")) p.T_BALLON_T = valeur;
        if (!strcmp(symbol, "T_NACELLE_T")) p.T_NACELLE_T = valeur;
        if (!strcmp(symbol, "T_BALLON_R")) p.T_BALLON_R = valeur;
        if (!strcmp(symbol, "T_NACELLE_R")) p.T_NACELLE_R = valeur;
        }
    fclose(param);
    }
else exit (-1);
}

// function to load control parameters from external file
void loadControl(void)
{
FILE * param;       // file pointer
char symbol[21];    // parameter symbol read
dReal valeur;       // parameter value read

param = fopen("../modeles/controle.par", "rt");
if(param) {
    while(!feof(param)) {
        fscanf(param,"%s %f", symbol, &valeur);
        if (!strcmp(symbol, "ECRAN"))       jc.ECRAN = valeur;
        if (!strcmp(symbol, "CHAUT"))       jc.CHAUT = valeur;
        if (!strcmp(symbol, "CBAS"))        jc.CBAS = valeur;
        if (!strcmp(symbol, "CAVANT"))      jc.CAVANT = valeur;
        if (!strcmp(symbol, "CARRIERE"))    jc.CARRIERE = valeur;
        if (!strcmp(symbol, "JHB"))         jc.JHB = valeur;
        if (!strcmp(symbol, "JAA"))         jc.JAA = valeur;
        if (!strcmp(symbol, "JGD"))         jc.JGD = valeur;
        if (!strcmp(symbol, "JTGD"))        jc.JTGD = valeur;
        if (!strcmp(symbol, "BSS"))         jc.BSS = valeur;
        if (!strcmp(symbol, "BNH"))         jc.BNH = valeur;
        if (!strcmp(symbol, "BZP"))         jc.BZP = valeur;
        if (!strcmp(symbol, "BZM"))         jc.BZM = valeur;
        if (!strcmp(symbol, "BVP"))         jc.BVP = valeur;
        if (!strcmp(symbol, "BVM"))         jc.BVM = valeur;
        }
    fclose(param);
    }
else exit (-2);
}

